#define REPEAT 40000000L

#ifndef POINTER
#  error POINTER must be defined!
#endif

int main(void)
{
int r, i, j;
#if POINTER == 1
int **v;
v = (int **)malloc(sizeof(int *)*3);
v[0] = (int *)malloc(sizeof(int)*3);
v[1] = (int *)malloc(sizeof(int)*3);
v[2] = (int *)malloc(sizeof(int)*3);
#elif POINTER == 2
int v[3][3];
#else
#  error POINTER must be defined!
#endif

  for (r = 0; r < REPEAT; r++)
    for (i = 1; i < 3; i++)
      for (j = 1; j < 3; j++)
        v[i][j] = 2*v[i-1][j-1] + v[i][j]*v[i-1][j-1];

return 0;
}

/*
Results: 11/29/2003 on Pentium III 400 Mhz laptop

>gcc -DPOINTER=1 array_access_test.c
>time ./a.out

real    0m12.672s
user    0m11.870s
sys     0m0.000s
-------------------------------------------------------
>gcc -DPOINTER=2 array_access_test.c
>time ./a.out

real    0m11.603s
user    0m10.870s
sys     0m0.010s

*/